#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
 

#define True 1
#define False 0

/*******************************************************************/
/* Function callBrowser                                            */
/*                                                                 */
/* open the file in the given browser                              */
/*                                                                 */
/*******************************************************************/

void callBrowser(char *browser, char *file)
{
   char   command[4096];
   int    isNetscape = False;
   int    isMozilla  = False;
   int    isGaleon   = False;
   char  *s;

   if ( browser && *browser )
   {
      s = strrchr(browser, '/');
      if ( s )
      {
         s++;
         if ( strcmp(s, "netscape") == 0 ||
              strcmp(s, "Netscape") == 0 )
         {
            isNetscape = True;
         }
         else if ( strcmp(s, "mozilla") == 0  ||
                   strcmp(s, "Mozilla") == 0   )
         {
            isMozilla = True;
         }
         else if ( strcmp(s, "galeon") == 0  )
         {
            isGaleon = True;
         }
      }
      else
      {
         if ( strcmp(browser, "netscape") == 0 ||
              strcmp(browser, "Netscape") == 0 )
         {
            isNetscape = True;
         }
         if ( strcmp(browser, "mozilla") == 0  ||
              strcmp(browser, "Mozilla") == 0   )
         {
            isMozilla = True;
         }
         else if ( strcmp(browser, "galeon") == 0  )
         {
            isGaleon = True;
         }
      }
   }
   else
   {
      browser = strdup("netscape");
      isNetscape = True;
   }

   /* remark about starting of netscape / mozilla                  */
   /* Solaris don't like "if ! netscape ...;then netscape ...;fi   */
   /* we use instead an if netscape ... then :;else netscape...;fi */
   /* : is a no op instruction for the shell                       */
   if ( isNetscape )
   {
      /* call netscape */
       sprintf(command,
            "if %s -remote \"openURL(file://%s)\";then :;else %s file://%s;fi &",
            browser, file, browser, file);
   }
   else  if ( isGaleon )
   {
      sprintf(command,"%s -x %s &",browser, file);
   }
   else  if ( isMozilla )
   {
       /* previous version of mozilla require file:///path/file */
       sprintf(command,
            "if %s -remote \"openURL(file://%s)\";then :;else %s file://%s; fi &",
            browser, file, browser, file);
   }
   else
   {
      /* most browser don't need an extra option */
      sprintf(command,"%s %s &",browser, file);
   }
   
   /* if we have root or lp rights, we have to get the uid instead */
   /* of the euid. start the browser as "daemon" */
   if ( fork() == 0 )
   {
      if ( fork() == 0 )
      {
         seteuid(getuid());
         system(command);
         exit(0);
      }
      exit(0);
      /* exit first subprocess */
   }
   /* wait for the first sub process and avoid a zomby */
   wait(&isGaleon);
}
