#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <strings.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <dirent.h>

#include "CanonUtilGlobal.h"

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif
static char *deviceList[] = {
   "/dev/lp0",      /* Linux */
   "/dev/lp1",	    /* on new kernel /dev/printer/0,... /dev/printer/3 */
   "/dev/lp2",
   "/dev/lp3",
   "/dev/printers/0",
   "/dev/printers/1",
   "/dev/printers/2",
   "/dev/printers/3",
   "/dev/usb/lp0",
   "/dev/usb/lp1",
   "/dev/usb/lp2",
   "/dev/usb/lp3",
   "/dev/usb/lp4",
   "/dev/usb/lp5",
   "/dev/usb/lp6",
   "/dev/usb/lp7",
   "/dev/usb/lp9",
   "/dev/usb/lp9",
   "/dev/usb/lp10",
   "/dev/usb/lp11",
   "/dev/usb/lp12",
   "/dev/usb/lp13",
   "/dev/usb/lp14",
   "/dev/usb/lp15",
   "/dev/usblp0",
   "/dev/usblp1",
   "/dev/usblp2",
   "/dev/usblp3",
   "/dev/usblp4",
   "/dev/usblp5",
   "/dev/usblp6",
   "/dev/usblp7",
   "/dev/usblp8",
   "/dev/usblp9",
   "/dev/usblp10",
   "/dev/usblp11",
   "/dev/usblp12",
   "/dev/usblp13",
   "/dev/usblp14",
   "/dev/usblp15",
   "/dev/ecpp0",       /* Solaris */
   "/dev/ecpp1",
   "/dev/ecpp2",
   "/dev/ecpp3",
   "/dev/ecpp4",
   "/dev/lpt0",        /* FreeBSD */
   "/dev/lpt1",
   "/dev/lpt2",
   NULL
};

void freeList(list_t *list)
{
   list_t *p = NULL;
   while(list)
   {
      if ( list->item )
         free(list->item);
      p = list;
      list = list->next;
      free(p);
   }
}

/* build a list for the available printers */

void getPrinterList()
{
   FILE *fp;
   char buffer[1024];
   list_t *l, *n;
   char   *s;

   if ( pList )
   {
      free(pList);
      pList = NULL;
   }
   
   n = pList = (list_t*)calloc(sizeof(list_t),1);
   n->item = strdup("-");
   l = n;

   fp = popen("/usr/sbin/lpc status | sed -n -e 's/\\(.*\\):/\\1/p'", "r");
   if ( fp )
   {
   
      while ( fgets(buffer,sizeof(buffer), fp)  )
      {
         s = strchr(buffer, '\n');
         if ( s ) *s = '\0';

         n = (list_t*)calloc(sizeof(list_t),1);
         n->item = strdup(buffer);
         l->next = n;
         l = n;
      }
      fclose(fp);
   }
}

void getDeviceList()
{
   int i;
   int found;
   struct stat status;
   int euid = geteuid();
   int egid = getegid();
   list_t *l, *n;

   if ( dList )
   {
      free(dList);
      dList = NULL;
   }
   
   for (i = 0;  deviceList[i] != NULL; i++)
   {
      /* acess as group or user */
      found = 0;
      if (access(deviceList[i],  R_OK|W_OK) == 0 )
      {
         found = 1;
      }
      else
      {
         if ( stat(deviceList[i],&status) == 0 )
         {
            /* access as root */
            if ((euid==0  && (status.st_mode & (S_IRUSR|S_IWUSR))==(S_IRUSR|S_IWUSR)))
            {
               found = 1;
            }
            else
            {
               /* access as an other priviliged user */
               if ( (int)status.st_uid == (int)euid )
               {
                  found = 1;
               }
               else
               {
                  /* privilged group ? */
                  if ( (int)status.st_gid == (int)egid && (status.st_mode & (S_IRGRP|S_IWGRP)) == (S_IRGRP|S_IWGRP))
                  {
                     found = 1;
                  }
               }
            }
         }
      }

      if ( found )
      {
         n = (list_t*)calloc(sizeof(list_t),1);
         n->item = strdup(deviceList[i]);
         if ( dList == NULL )
            dList = n;
         else
            l->next = n;
         l = n;
      }
   }
}

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif
