// generated by Fast Light User Interface Designer (fluid) version 1.0102

#include <FL/x.H>       /* for OS functions */
#include <stdio.h>
#include <gettext.h>
#include <CanonUtilGlobal.h>
#include <CanonUtilStatus.h>
#include <doPrint.h>
#include <findHtmlFile.h>

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/fl_draw.H>
#include <FL/Fl_Pack.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Choice.H>

#include "CanonUtilFltkMw.h"
#include "CanonUtilFltkUtil.h"
#include "CanonUtilFltkHtmlWin.h"
#include "CanonUtilFltkPref.h"
#include "CanonUtilFltkMsg.h"
#include "CanonUtilFltkTime.h"
#include "CanonUtilFltkWait.h"
#include "fltkGl.h"

static Fl_Box       *mainTitle = (Fl_Box *)0;
static Fl_Button    *button[10];
static Fl_Button    *lbutton[4];
static Fl_Button    *sbutton;
static Fl_Window    *mainWindow;
static Fl_Box       *sep1;
static Fl_Box       *sep2;

//static char *pbLabel[2] = { "Cancel", "OK" };
//static char *pBLabel[2] = { "PrinterSelection", "DeviceSelection" };
static char *mainTitleLB = { "CanonBjCUtility" };
static char *lbLabel[4];
static char *bLabel[10];

static void setLabelName()
{
   bLabel[NOZZLE_CHECK] = "print_nozzle_check";
   bLabel[POW_OFF     ] = "power_off";
   bLabel[CLEAN_B     ] = "clean_black_head";
   bLabel[DIS_AP_OFF  ] = "auto_power_off_disabled";
   bLabel[CLEAN_A     ] = "clean_both_head";
   bLabel[EN_AP_OFF   ] = "auto_power_off_enabled";
   bLabel[ADJUST_H    ] = "auto_adjust_head";
   bLabel[DIS_AP_ON   ] = "auto_power_on_disabled";
   bLabel[RESET_P     ] = "reset_printer";
   bLabel[EN_AP_ON    ] = "auto_power_on_enabled";

   lbLabel[PREF       ] = "Configure";
   lbLabel[ABOUT      ] = "About";
   lbLabel[HELP       ] = "Help";
   lbLabel[EXIT       ] = "Quit";
}

static void buttonCallback(Fl_Widget *b, void *data)
{
   int i = (int)data;
   char *arg = NULL;
   if ( (printer == NULL || *printer == '-') && device == NULL )
   {
      make_MsgWin(getText("noPrinter"));
      return;
   }
   switch(i)
   {
      case EN_AP_OFF:
         /* get argument, "1", ... ""60" */
         make_TimeWindow();
         if ( powerOffTime )
         {
            arg = powerOffTime;
         }
      default:
         i = sendToLp(i, printer, arg);
         if ( ! i )
         {
            make_MsgWin(getText("msgCommError"));
         }
   }
}
 
static void lbuttonCallback(Fl_Widget *b, void *data)
{
   int i = (int)data;
   char *f;
   switch(i)
   {
      case EXIT:
         mainWindow->hide(); /* and exit */
      break;
      case ABOUT:
         make_HelpWin(ABOUT, NULL);
         /* show the about box */
      break;
      case HELP:
         /* show the help window */
         if ( ( f = findHtmlFile("CanonUtil",language) ) )
         {
            make_HelpWin(HELP, f);
         }
         else
         {
            make_HelpWin(HELP, "CanonUtil.html");
         }
      break;
      case PREF:
         /* show the preference window */
         make_PrefWindow();
      break;
   }
}

static void sbuttonCallback(Fl_Widget *b, void *data)
{

   make_waitWin();
}
 
static void layout(void)
{
   int i;
   int maxw    = 0;
   int maxbw   = 0;
   int maxbh   = 0;
   int lh      = 0;
   int lbh     = 0;
   int lbw     = 0;
   int w, h;
   short x, y;
   
   getTextSize((Fl_Widget*)mainTitle, &w,&h);
   maxw = w;
   lh   = h;

   for ( i = 0; i < 10; i++ )
   {
      getTextSize((Fl_Widget*)button[i], &w,&h);
      if ( w > maxbw ) maxbw = w;
      if ( h > maxbh ) maxbh = h;
   }
   getTextSize((Fl_Widget*)sbutton, &w,&h);
   if ( w > maxbw ) maxbw = w;
   if ( h > maxbh ) maxbh = h;
   w = maxbw + 5 + maxbw;

   if ( w > maxw ) maxw = w;
   
   for ( i = 0; i < 4; i++ )
   {
      getTextSize((Fl_Widget*)lbutton[i], &w,&h);
      if ( w > lbw ) lbw = w;
      if ( h > lbh ) lbh = h;
   }
   w = lbw * 4 + 15;
   if ( w > maxw ) maxw = w;
   else if ( w < maxw ) lbw = (maxw-15)/4;

   /* set position and size of widgets */
   y = 5;
   mainTitle->size(maxw, lh);
   mainTitle->position(5, y);
   y += lh + 10;
 
   if ( maxbw < lbw*2+5 )
      maxbw = lbw*2+5;
  
   for ( i = 0; i < 10; i++)
   {
      button[i]->size(maxbw,maxbh);
      if ( (i % 2) == 0 )
      {
         button[i]->position(5, y);
      }
      else
      {
         x = 10 + maxbw;
         button[i]->position(x, y);
         y += 5 + maxbh;
      }
   }
   
   sep1->resize(0,y, maxw+10,1);
   y += 6;

   sbutton->resize(5,y,maxbw,maxbh);
   y += maxbh+5;
   

   sep2->size(maxw+10,1);
   sep2->position(0,y);
   y += 10;
   
   for ( i = 0; i < 4; i++)
   {
      lbutton[i]->size(lbw,lbh);
      x = (i*5) + 5 + lbw*i;
      lbutton[i]->position(x, y);
   }
   y += 3+lbh;
   
   /* set size of main window */
   mainWindow->size(maxw+10, y+5);
}

void redrawMainWin()
{
   int i;
   Fl_Boxtype t;
   if ( useGL )
   {
      /* set all pushbutton to FL_UP_BOX */
      t = FL_UP_BOX;
   }
   else  if ( normalButton )
   {
      t = FL_UP_BOX;
   }
   else
   {
      t = FL_PLASTIC_UP_BOX;
   }
   for ( i = 0; i < 10; i++ )
      button[i]->box(t);
   for ( i = 0; i < 4; i++ )
      lbutton[i]->box(t);
   sbutton->box(t);
   if ( !useGL )
      mainWindow->box(FL_FLAT_BOX);
   setGlWin(mainWindow);
   mainWindow->redraw();
}

Fl_Window *makeMainWindow() {
  Fl_Window* w;
  int i;
  setLabelName();
  { Fl_Window* o = mainWindow = new Fl_Window(10, 10);
    w = o;
    o->label(prgName);
    { Fl_Box* o = mainTitle = new Fl_Box(5, 5, 10, 10, getText(mainTitleLB));
      o->box(FL_FLAT_BOX);
      o->color(7);
      o->labelsize(18);
      o->labelcolor(1);
      o->align(FL_ALIGN_CLIP);
    }

    sbutton = new Fl_Button(0, 0, 0, 0, getText("statusButton"));
    setButton(sbutton);
    sbutton->callback(sbuttonCallback, (void*)0);

    { Fl_Box* o = sep1 = new Fl_Box(5,5,10,5, 0);
      o->box(FL_ENGRAVED_FRAME);
    }
    
    for ( i = 0; i < 10; i++)
    {
      button[i] = new Fl_Button(0, 0, 0, 0, getText(bLabel[i]));
      setButton(button[i]);
      button[i]->callback(buttonCallback, (void*)i);
    }
    for ( i = 0; i < 4; i++)
    {
      lbutton[i] = new Fl_Button(0, 0, 0, 0, getText(lbLabel[i]));
      setButton(lbutton[i]);
      lbutton[i]->callback(lbuttonCallback, (void*)i);
    }

    { Fl_Box* o = sep2 = new Fl_Box(5,5,10,5, 0);
      o->box(FL_ENGRAVED_FRAME);
    }
    o->end();
  }
  layout();
  setGlWin(w);
  return w;
}
