/* timme entry window
 */
#include <FL/x.H>
#include <FL/Fl.H>
#include <stdlib.h>
#include <string.h>
#include "CanonUtilGlobal.h"
#include "gettext.h"
#include <stdio.h>

#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Button.h>
#include <FL/Fl_Choice.h>
#include <FL/Fl_Int_Input.H>
#include "CanonUtilFltkUtil.h"
#include "CanonUtilFltkMsg.h"
#include "fltkGl.h"

static char *pbLabel[2] = { "Cancel", "OK" };
static char *mainTitleLB = { "CanonBjCUtility" };

static Fl_Window     *timeWin = 0;
static Fl_Box        *timeTitle;
static Fl_Button     *tbutton[2];
static Fl_Box        *timeBox;
static Fl_Int_Input  *timeIn;
static Fl_Box        *timeSep;


static void tbuttonCallback(Fl_Widget *w, void  *data)
{
   int i = (int)data;
   if ( i == 0 )
   {
   }
   else
   {
      char *s = strdup(timeIn->value());
      i = atoi(s);
      if ( i < 1 || i > 60 )
      {
         make_MsgWin(getText("msgSelectionTime"));
         free(s);
         return;
      }
      else
      {
         if ( powerOffTime )
         {
            free(powerOffTime);
            powerOffTime = NULL;
         }
         powerOffTime = s;
      }
   }
   delete timeWin;
}

static void tlayout()
{
   int tw, th;
   int maxw = 0;
   int mbow = 0, mboh = 0;
   int minw = 0, minh = 0;
   int mbuw = 0, mbuh = 0;
   int w, h;
   int y;
   int i;
   
   getTextSize((Fl_Widget*)timeTitle, &tw,&th);
   getTextSize((Fl_Widget*)timeBox, &mbow, &mboh);
   getTextSize((Fl_Widget*)timeIn, &minw, &minh);
   getTextWidth((Fl_Widget*)timeIn,"60", &minw);
   if ( mboh < minh ) mboh = minh;
   else               minh = mboh;

   for ( i = 0; i < 2; i++ )
   {
      getTextSize((Fl_Widget*)tbutton[i], &w, &h);
      if ( w > mbuw ) mbuw = w;
      if ( h > mbuh ) mbuh = h;
   }
   
   /* calculate max width */
   maxw = tw + 10;
   w = 5 + mbow + 5 + minw + 5;
   if ( maxw < w ) maxw = w;
   w = 5 + mbuw + 5 + mbuw + 5;
   if ( maxw < w ) maxw = w;

   /* position and size */

   y = 5;
   timeTitle->resize(5,y,maxw-10,th);
   y += 10 + th;
   timeBox->resize(5,y,mbow, mboh);
   timeIn->resize(maxw-5-minw, y, minw, minh);
   y += 10 + mboh;

   timeSep->resize(0,y, maxw,1);
   y += 10;

   tbutton[1]->resize(5,y,mbuw, mbuh);
   tbutton[0]->resize(maxw-5-mbuw,y, mbuw, mbuh);
   y += 10 + mbuh;
   timeWin->size(maxw, y);
   
}

void make_TimeWindow()
{
   int i;
   timeWin = new Fl_Window(10,10);
   timeWin->set_modal();
   timeWin->label(prgName);
   
   { Fl_Box* o = timeTitle = new Fl_Box(5, 5, 10, 10, getText(mainTitleLB));
     o->box(FL_FLAT_BOX);
     o->color(7);
     o->labelsize(18);
     o->labelcolor(1);
     o->align(FL_ALIGN_CLIP);
   }
   
   {  Fl_Box* o = timeBox = new Fl_Box(5, 5, 10, 10, getText("SelectionTime"));
      if ( !useGL )
         o->box(FL_FLAT_BOX);
      o->align(FL_ALIGN_INSIDE|FL_ALIGN_LEFT);
   }

   {  Fl_Int_Input* o = timeIn = new Fl_Int_Input(5, 5, 10, 10);
      o->maximum_size(2);
      if ( powerOffTime )
         o->insert(powerOffTime);
      o->box(FL_THIN_DOWN_BOX);
   }

   timeSep = new Fl_Box(5,5,10,5, 0);
   timeSep->box(FL_ENGRAVED_FRAME);
  
   for ( i = 0; i < 2; i++)
   {
     tbutton[i] = new Fl_Button(0, 0, 0, 0, getText(pbLabel[i]));
     setButton(tbutton[i]);
     tbutton[i]->callback(tbuttonCallback, (void*)i);
   }
   timeWin->end();
   tlayout();
   setGlWin(timeWin);
   timeWin->show();
}
